import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class BatchUpdateUsingJDBCPreparedStatement {

	public static void main(String[] args) {

		// variables
		Connection connection = null;
		PreparedStatement preparedStatement = null;

		// Step 1: Loading or registering MySQL JDBC driver class
		try {
			Class.forName("com.mysql.jdbc.Driver");
		}
		catch(ClassNotFoundException cnfex) {
			System.out.println("Problem in loading or registering MySQL JDBC driver");
			cnfex.printStackTrace();
		}

		// Step 2: Opening database connection
		try {

			// Step 2.A: Create and get connection using DriverManager class
			connection = DriverManager.getConnection("jdbc:mysql://localhost:3306/PLAYER_INFO", "root", "root@123"); 

			// Start of JDBC transaction
			connection.setAutoCommit(false);

			// create SQL query to update PLAYER info
			String sqlUpdateQuery = "UPDATE PLAYER SET AGE = ? WHERE PLAYER_ID = ?";

			// Step 2.B: Creating JDBC Statement 
			preparedStatement = connection.prepareStatement(sqlUpdateQuery);

			// 1st PLAYER info update
			preparedStatement.setInt(1, 46);
			preparedStatement.setInt(2, 2);
			preparedStatement.addBatch();

			// 2nd PLAYER info update
			preparedStatement.setInt(1, 35);
			preparedStatement.setInt(2, 3);
			preparedStatement.addBatch();

			// 3rd PLAYER info update
			preparedStatement.setInt(1, 35);
			preparedStatement.setInt(2, 6);
			preparedStatement.addBatch();

			// Step 2.C: Executing SQL & retrieve data into ResultSet
			preparedStatement.executeBatch();

			// End of JDBC transaction
			connection.commit();

			System.out.println("All PLAYER info updation is successfull using JDBC PreparedStatement Interface");
		}
		catch(SQLException sqlex){
			sqlex.printStackTrace();
		}
		finally {

			// Step 3: Closing database connection
			try {
				if(null != connection) {

					// cleanup resources, once after processing
					preparedStatement.close();

					// and then finally close connection
					connection.close();
				}
			}
			catch (SQLException sqlex) {
				sqlex.printStackTrace();
			}
		}
	}
}